﻿Option Strict On
Imports Softbuild.Media
Imports Windows.Storage

' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください

''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
Public NotInheritable Class MainPage
    Inherits Page

    ''' <summary>
    ''' このページがフレームに表示されるときに呼び出されます。
    ''' </summary>
    ''' <param name="e">このページにどのように到達したかを説明するイベント データ。Parameter 
    ''' プロパティは、通常、ページを構成するために使用します。</param>
    ''' 
    Dim myImageList As New List(Of BitmapImage)
    Dim myPictureFiles As IReadOnlyList(Of IStorageFile)
    Dim fileNameList As New List(Of String)
    Dim mySubFolder As StorageFolder
    Dim mySource As WriteableBitmap
    Protected Overrides Async Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)

        Dim pictureFolder As StorageFolder = KnownFolders.PicturesLibrary
        Dim myPictureFiles As IReadOnlyList(Of IStorageFile) = Await pictureFolder.GetFilesAsync()
        If myPictureFiles.Count > 0 Then
            ichiranButton.IsEnabled = True
        Else
            ichiranButton.IsEnabled = False
        End If

        mySubFolder = Await pictureFolder.CreateFolderAsync("ageRecords", CreationCollisionOption.OpenIfExists)
        Dim mySubPictureFiles As IReadOnlyList(Of IStorageFile) = Await mySubFolder.GetFilesAsync()
        For Each myFile In mySubPictureFiles
            Dim bmp As New BitmapImage
            bmp.SetSource(Await myFile.OpenReadAsync)
            myImageList.Add(bmp)
            fileNameList.Add(Path.GetFileName(myFile.Path))
            Dim myImage As New Image
            myImage.Width = 320
            myImage.Height = 240
            myImage.Source = bmp
            GridView1.Items.Add(myImage)
        Next
    End Sub

    Private Sub GridView1_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles GridView1.SelectionChanged
        bakumatsuButton.IsEnabled = True
        grayButton.IsEnabled = True
        negativeButton.IsEnabled = True
        sepiaButton.IsEnabled = True
        SaturationButton.IsEnabled = True
        VignettingButton.IsEnabled = True
        ToycameraButton.IsEnabled = True
        PosterizeButton.IsEnabled = True
        contrastButton.IsEnabled = True
        Dim selectImage = myImageList(GridView1.SelectedIndex)
        Image1.Source = selectImage
        messageTextBlock.Text = String.Empty
    End Sub

    Private Sub okButton_Click(sender As Object, e As RoutedEventArgs) Handles okButton.Click
        Dim no As Integer = 0
        For Each resut In fileNameList.ToList
            Dim selectText = resut.Substring(0, 10)
            If selectText = searchTextBox.Text Then
                GridView1.SelectedIndex = no
                GridView1.ScrollIntoView(GridView1.Items(no))
                Exit For
            End If

            no += 1
        Next
    End Sub

    Private Async Function GetTestImageAsync() As Task(Of WriteableBitmap)
        Dim imageFile As StorageFile = Await mySubFolder.GetFileAsync(fileNameList(GridView1.SelectedIndex))
        Return Await WriteableBitmapExtensions.FromStreamAsync(Await imageFile.OpenReadAsync)
    End Function
    Private Async Sub bakumatsuButton_Click(sender As Object, e As RoutedEventArgs) Handles bakumatsuButton.Click
        Dim myBmp = Await GetTestImageAsync()
        mySource = Await myBmp.EffectBakumatsuAsync
        Image1.Source = mySource
        saveButton.IsEnabled = True
    End Sub

    Private Async Sub grayButton_Click(sender As Object, e As RoutedEventArgs) Handles grayButton.Click
        Dim myBmp = Await GetTestImageAsync()
        mySource = myBmp.EffectGrayscale
        Image1.Source = mySource
        saveButton.IsEnabled = True
    End Sub

    Private Async Sub negativeButton_Click(sender As Object, e As RoutedEventArgs) Handles negativeButton.Click
        Dim myBmp = Await GetTestImageAsync()
        mySource = myBmp.EffectNegative
        Image1.Source = mySource
        saveButton.IsEnabled = True
    End Sub

    Private Async Sub sepiaButton_Click(sender As Object, e As RoutedEventArgs) Handles sepiaButton.Click
        Dim myBmp = Await GetTestImageAsync()
        mySource = myBmp.EffectSepia
        Image1.Source = mySource
        saveButton.IsEnabled = True
    End Sub

    Private Async Sub SaturationButton_Click(sender As Object, e As RoutedEventArgs) Handles SaturationButton.Click
        Dim myBmp = Await GetTestImageAsync()
        mySource = myBmp.EffectSaturation(1.0)
        Image1.Source = mySource
        saveButton.IsEnabled = True
    End Sub

    Private Async Sub VignettingButton_Click(sender As Object, e As RoutedEventArgs) Handles VignettingButton.Click
        Dim myBmp = Await GetTestImageAsync()
        mySource = Await myBmp.EffectVignettingAsync(1.0)
        Image1.Source = mySource
        saveButton.IsEnabled = True
    End Sub

    Private Async Sub ToycameraButton_Click(sender As Object, e As RoutedEventArgs) Handles ToycameraButton.Click
        Dim myBmp = Await GetTestImageAsync()
        mySource = Await myBmp.EffectToycameraAsync
        Image1.Source = mySource
        saveButton.IsEnabled = True
    End Sub

    Private Async Sub PosterizeButton_Click(sender As Object, e As RoutedEventArgs) Handles PosterizeButton.Click
        Dim myBmp = Await GetTestImageAsync()
        mySource = myBmp.EffectPosterize(255)
        Image1.Source = mySource
        saveButton.IsEnabled = True
    End Sub

    Private Async Sub contrastButton_Click(sender As Object, e As RoutedEventArgs) Handles contrastButton.Click
        Dim myBmp = Await GetTestImageAsync()
        mySource = myBmp.EffectContrast(1.0)
        Image1.Source = mySource
        saveButton.IsEnabled = True
    End Sub

    Private Async Sub saveButton_Click(sender As Object, e As RoutedEventArgs) Handles saveButton.Click
        Dim myBmp = DirectCast(Image1.Source, WriteableBitmap)
        Await myBmp.SaveAsync(ImageFormat.Png, ImageDirectories.PicturesLibrary, DateTime.Now.ToString("yyyyMMddHHmmss"), 640, 480)
        ichiranButton.IsEnabled = True
        messageTextBlock.Text = "Picturesフォルダに保存しました。"
    End Sub

    Private Async Sub ichiranButton_Click(sender As Object, e As RoutedEventArgs) Handles ichiranButton.Click
        Dim myPictureFolder = KnownFolders.PicturesLibrary
        Dim myPictureFiles As IReadOnlyList(Of IStorageFile) = Await myPictureFolder.GetFilesAsync()
        ListBox1.Items.Clear()
        For Each myFile In myPictureFiles
            Dim bmp As New BitmapImage
            bmp.SetSource(Await myFile.OpenReadAsync)
            'myImageList.Add(bmp)
            'fileNameList.Add(Path.GetFileName(myFile.Path))
            Dim myImage As New Image
            'myImage.Margin = New Thickness(0, 0, 0, 0)
            myImage.Width = 320
            myImage.Height = 240
            myImage.Source = bmp
            ListBox1.Items.Add(myImage)
        Next

    End Sub

End Class
